import 'package:flutter/cupertino.dart';
import 'package:nui_core/code/nui_code_util.dart';
import 'package:nui_core/ui/component/listview/nui_list_interface.dart';
import 'package:nui_core/ui/component/listview/nui_list_item_repo.dart';
import 'package:nui_core/ui/component/listview/nui_listview_bloc.dart';
import '../nui_shader_mask.dart';
import 'nui_listview_builder.dart';
import 'nui_listview_functions.dart';

@Deprecated("NUIAnimatedList is deprecated, use NUIAnimatedHeaderList instead")
class NUIAnimatedList<T, C> extends NUIAnimatedListInterface<T, C> {
  NUIAnimatedList({
    @required NUIListViewBloc<T, C> bloc,
    @required NUIListItemRepository repo,
    @required List<T> initialList,
    @required OnListItemClickListener clickListener,
    bool shrinkWrap: false,
    double startDivider,
    double endDivider,
    double middleDivider,
    ListFixedItemGetter fixedFirstItem,
    ListFixedItemGetter fixedLastItem,
    Axis orientation: Axis.vertical,
    EdgeInsets padding,
    bool enablePagination: false,
    bool enableSwipeRefresh: false,
    int minimumPaginateCount: 5,
    NUILoadingListItem skeletalInflater,
    NUILoadingListItem paginationInflater,
    ListShadowInflater shadowInflater,
    ListPlaceHolderInflater placeHolder,
    ListErrorHolderInflater errorHolder,
    NUIListScrollListener scrollListener,
    int skeletalCount: 1,
    ScrollPhysics scrollPhysics,
    NUIShaderMaskType shaderType,
    Map<String, dynamic> checkedMap,
    Map<String, dynamic> configMap,
    NUIListItemAnimation itemAnimation: NUIListItemAnimation.SCALE
  }) : super(
      repo: repo,
      initialList: initialList,
      orientation: orientation,
      padding: padding,
      shrinkWrap: shrinkWrap,
      startDivider: startDivider,
      endDivider: endDivider,
      middleDivider: middleDivider,
      fixedFirstItem: fixedFirstItem,
      fixedLastItem: fixedLastItem,
      checkedMap: checkedMap,
      configMap: configMap,
      clickListener: clickListener,
      skeletalCount: skeletalCount,
      errorHolder: errorHolder,
      scrollListener: scrollListener,
      shaderType: shaderType,
      placeHolder: placeHolder,
      skeletalInflater: skeletalInflater,
      paginationInflater: paginationInflater,
      scrollPhysics: scrollPhysics,
      enablePagination: enablePagination,
      enableSwipeRefresh: enableSwipeRefresh,
      minimumPaginateCount: minimumPaginateCount,
      bloc: bloc,
      itemAnimation : itemAnimation ?? NUIListItemAnimation.SCALE
  );

  @override
  _NUIAnimatedListState<T, C> createState() => _NUIAnimatedListState<T, C>();
}

class _NUIAnimatedListState<T, C> extends NUIAnimatedListState<T, C, NUIAnimatedList<T, C>> {

  @override
  Widget getListView(int initialCount){
    logNUI("NUIAnimatedList", "Building animated list view");
    return AnimatedList(
        physics: widget.scrollPhysics ?? NUICustomScrollPhysics(),
        padding: widget.padding,
        scrollDirection: widget.orientation,
        shrinkWrap: widget.shrinkWrap ?? false,
//        controller: scrollController(),
        key: listKey,
        initialItemCount: initialCount,
        itemBuilder: (context, position, animation){
          if(position < items.length) {
            return animateItem(context, position, animation);
          }
          return null;
        });
  }

}



